﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PHPScan.LexicalAnalysis
{
    public static class PhpParse
    {
        public static Dictionary<string, List<string>> GetSuperglobalFields(Token[] tokens)
        {
            tokens = tokens
                .Where(x => x.TokenType != TokenType.WhiteSpace &&
                    x.TokenType != TokenType.Comment)
                .ToArray();

            var fieldDictionary = PHP.Superglobals
                .ToDictionary(x => x, x => new List<string>());
            
            for (int i = 0; i < tokens.Length; i++)
                if (PHP.Superglobals.Contains(tokens[i].Lexeme))
                {
                    int state = 0;
                    string fieldName = null;

                    for (int j = i + 1; j < tokens.Length; j++)
                    {
                        //if (tokens[j].TokenType == TokenType.Comment ||
                        //    tokens[j].TokenType == TokenType.WhiteSpace)
                        //    continue;
                        
                        if (state == 0 && tokens[j].TokenType == TokenType.LeftBracket)
                        {
                            state = 1;
                        }
                        else if (state == 1 && tokens[j].TokenType == TokenType.String)
                        {
                            state = 2;
                            fieldName = tokens[j].Lexeme;
                        }
                        else if (state == 2 && tokens[j].TokenType == TokenType.RightBracket)
                        {
                            state = 3;
                            break;
                        }
                        else
                            break;
                    }

                    if (state == 3)
                    {
                        var name = fieldName.Substring(1, fieldName.Length - 2);

                        if (!fieldDictionary[tokens[i].Lexeme].Contains(name))
                            fieldDictionary[tokens[i].Lexeme].Add(name);
                    }
                }

            return fieldDictionary;
        }
    }
}
