﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PHPScan.LexicalAnalysis
{
    public enum TokenType : short
    {
        Html,

        OpenTag,
        CloseTag,
        OpenWithEcho,

        Keyword,

        Comment,

        Ampersand,
        Comma,
        DoubleColon,
        Namespace,
        ErrorSuppressor,

        String,

        Identifier,
        Variable,

        LeftParenthesis,
        RightParenthesis,
        LeftBracket,
        RightBracket,
        LeftBrace,
        RightBrace,

        // Assignment operators
        AssignmentOperator,
        PlusEqualOperator,
        MinusEqualOperator,
        MultiplicationEqualOperator,
        DivisionEqualOperator,
        ModulusEqualOperator,
        ConcatEqualOperator,
        OrEqualOperator,
        XorEqualOperator,

        // Arithmetic/string operators
        AdditionOperator,
        SubtractionOperator,
        MultiplicationOperator,
        DivisionOperator,
        ModulusOperator,
        IncrementOperator,
        DecrementOperator,
        StringConcatOperator,

        // Logical operators        
        NotOperator,
        AndOperator,
        OrOperator,
        XorOperator,

        // Comparison operators
        EqualityOperator,
        IdenticalOperator,
        NotEqualOperator,
        NotIdenticalOperator,
        LessThanOperator,
        GreaterThanOperator,
        LessThanOrEqualOperator,
        GreaterThanOrEqualOperator,
        TernaryOperator,


        EndOfStatement,

        Number,

        WhiteSpace,

        Unknown,

        EndOfFile
    }
}
