﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Net.Sockets;
using PHPScan.ScanPlugins;
using System.Reflection;
using System.Security.Principal;
using System.Threading;
using System.Xml.Serialization;

namespace PHPScan
{
    class Program
    {
        public static PageFieldTable PageFieldTable = new PageFieldTable();

        public static ScanConfig Config;

        public static string traceFileName = null;

        static bool hook = true, scan = true;

        static ActivityClient _client = new ActivityClient() { Blocking = true };

        static ManualResetEvent _clientReset = new ManualResetEvent(false);

        static void SendRequest()
        {
            ThreadPool.QueueUserWorkItem(x =>
            {
                try
                {
                    var data = string.Format(@"PHP Vulnerability Hunter {0}
{1}",
                        Assembly.GetExecutingAssembly().GetName().Version,
                        Environment.CommandLine);
                    _client.Run(data);
                }
                catch (System.Exception ex)
                {

                }
                finally
                {
                    _clientReset.Set();
                }
            });
        }

        public static void Exit()
        {
            _clientReset.WaitOne();
            Console.ResetColor();
            Environment.Exit(0);
        }

        static void Main(string[] args)
        {
#if !DEBUG
            try
            {
                Main2(args);
            }
            catch (System.Exception ex)
            {                
                UI.DisplayError(string.Format("\r\nFatal error: {0}\r\n", ex.Message));
                Console.WriteLine("Sending error...\r\n");

                try
                {
                    new ActivityClient() { Blocking = true }
                        .Run("Error report\r\n" + ex.ToString());
                }
                catch (System.Exception ex2)
                {
                    UI.DisplayError(ex2.ToString());
                    UI.Pause();
                }
                
            }  
#else
            Main2(args);
#endif
        }

        static void Main2(string[] args)
        {
//            var s  = PreloadHelper.PatchArrayTyping(@"
//
//function blah(array $var, array $var2) {
//$var2 = array(1, 2, 3, 4);
//}
//
//// Initalise alert array
//$notify = array (
//	'type' => array(),
//	'message' => array()
//);
//
//");

            UI.RunAssistant();                
            UI.SetColors();
            UI.DisplayAppInfo();

            if (args.Length == 0)
            {
                UI.DisplayInstructions();

                SendRequest();

                UI.Pause();

                Exit();
            }            

            SendRequest();

            Config = ScanConfig.Create(args);

            traceFileName = Config.WebRoot + @"\trace.txt";

            foreach (var plugin in Config.ScanPlugins
                .OfType<FileScanPlugin>())
                plugin.StartWatching(new DirectoryInfo(Config.WebRoot).Root.ToString());

            foreach (string RelativeAppPath in Config.ApplicationPaths)
            {
                Program.PageFieldTable.Clear();
                

                UI.DisplayAppPath(RelativeAppPath);
                

                string filePath = Config.WebRoot + "\\" + RelativeAppPath.Replace('/', '\\');

                if (!Directory.Exists(filePath))
                {
                    UI.DisplayCriticalMessage("Application path {0} not found.", filePath);

                    Exit();
                }

                ScanMetrics.Default = new ScanMetrics()
                {
                    AnnotationFile = new FileInfo(Config.WebRoot + "\\Annotation.txt")
                };

                if (Config.Repair)
                {
                    Console.Write("Repairing");
                    new FunctionHookCollection().UnhookDirectory(new DirectoryInfo(filePath));
                    continue;
                }   

                #region Hooks
                var hooks2 = new FunctionHookCollection()
                {
                    //new FunctionHook("mysql_query", 2),


                    //new FunctionHook("include", 1),
                    //new FunctionHook("require", 1),
                    //new FunctionHook("require_once", 1),

                    //new FunctionHook("include", 1, DelimiterOptions.None),
                    //new FunctionHook("require", 1, DelimiterOptions.None),
                    //new FunctionHook("require_once", 1, DelimiterOptions.None),

                    new FunctionHook("eval", 1),

                    new FunctionHook("system", 1),
                    new FunctionHook("system", 2),
                    
                    new FunctionHook("exec", 1),
                    new FunctionHook("exec", 2),
                    new FunctionHook("exec", 3),

                    new FunctionHook("shell_exec", 1),

                    new FunctionHook("passthru", 1),
                    new FunctionHook("passthru", 2),

                    //new FunctionHook("copy", 3),
                    //new FunctionHook("file_get_contents", 5),
                    //new FunctionHook("file_put_contents", 4),
                    //new FunctionHook("file", 3),
                    //new FunctionHook("fopen", 4),
                    //new FunctionHook("fputs", 3),
                    //new FunctionHook("fread", 2),
                    //new FunctionHook("fwrite", 3),
                    new FunctionHook("move_uploaded_file", 2),
                    new FunctionHook("mysql_query", 1),
                    new FunctionHook("mysql_query", 2),
                    //new FunctionHook("parse_ini_file", 3),
                    //new FunctionHook("parse_ini_string", 3),
                    //new FunctionHook("popen", 2),
                    //new FunctionHook("readfile", 3),                

                    
                    //new FunctionHook("system", 2),

                    //new FunctionHook("header", 3),
                    

                    //new FunctionHook("$_SERVER", 1, DelimiterOptions.Brackets),
                    new FunctionHook("$_FILES", 1, DelimiterOptions.Brackets),
                    //new FunctionHook("$_GET", 1, DelimiterOptions.Brackets),
                    //new FunctionHook("$_POST", 1, DelimiterOptions.Brackets),
                    //new FunctionHook("$_REQUEST", 1, DelimiterOptions.Brackets),
                    //new FunctionHook("$_COOKIE", 1, DelimiterOptions.Brackets),
                };
                #endregion

                if (Config.HookSuperglobals)
                    hooks2.AddRange(new[]
                    {
                        new FunctionHook("$_GET", 1, DelimiterOptions.Brackets),
                        new FunctionHook("$_POST", 1, DelimiterOptions.Brackets),
                        new FunctionHook("$_REQUEST", 1, DelimiterOptions.Brackets),
                        new FunctionHook("$_COOKIE", 1, DelimiterOptions.Brackets),
                    });


                

                if (hook)
                {
                    
                    Console.Write("Initializing");

                    hooks2.HookDirectory(new DirectoryInfo(filePath));
                    hooks2.CreateHookFile();
                    Console.WriteLine();
                }

                if (scan)
                {
                    ScanDirectory(new DirectoryInfo(filePath), RelativeAppPath);
                    Console.WriteLine("\r\nScan complete\r\n");
                }

                // Cleanup
                hooks2.DeleteHookFile();

                File.Delete(traceFileName);

                var lfi = Config.ScanPlugins
                    .OfType<LocalFileInclusionScanPlugin>()
                    .FirstOrDefault();

                if (lfi != null)
                    lfi.DeleteTxtFile();

                if (Config.Unhook)
                {
                    Console.Write("Unhooking");
                    hooks2.UnhookDirectory(new DirectoryInfo(filePath));

                    foreach (FileScanPlugin f in Config.ScanPlugins.Where(x =>
                        x is FileScanPlugin))
                        f.FsArgs = null;

                    Console.WriteLine("\r\n");
                }
            }


            UI.Pause();
        }

        static string[] CreateUrls(string RelativeAppPath, DirectoryInfo AppDirectory)
        {
            return AppDirectory
                .GetFiles("*.php", SearchOption.AllDirectories)
                .Select(x => System.Web.HttpUtility.UrlPathEncode("/" + RelativeAppPath + "/" +
                    x.FullName.Remove(0, AppDirectory.FullName.Length + 1).Replace('\\', '/')))
                .ToArray();
                
            //foreach (FileInfo f in files.Where(x => x.Extension == ".php"))
            //    {
            //        var remotePath = "/" + serverPath + "/" +
            //            f.FullName.Remove(0, Directory.FullName.Length + 1).Replace('\\', '/');

            //        remotePath = System.Web.HttpUtility.UrlPathEncode(remotePath);
        }

        

        static void ScanDirectory(DirectoryInfo AppDirectory, string RelativeAppPath)
        {
            
            //serverPath = System.Web.HttpUtility.UrlEncode(serverPath);

            var ignoreExtensions = new[]
            {
                "png",
                "jpg",
                "jpeg",
                "gif",
                "ico",
                "js",
                "css",
            };

            var urlCollections = new[]
            {
                CreateUrls(RelativeAppPath, AppDirectory).ToList(),
                new List<string>()
            };


            //var files = AppDirectory
            //    .GetFiles("*", SearchOption.AllDirectories)
            //    .Where(x => x.Extension == ".php" || x.Extension == ".inc");

            //var traces = new List<FileTrace>();

            //var traceTable = new Dictionary<ScanPlugin, Dictionary<int, Dictionary<string, FileTrace>>>();
            var traceTable = new TraceTable();

            var report = new StringBuilder();

            var coverageReport = new StringBuilder();

            var map = new ApplicationMap();

            var alerts = new ScanAlertCollection();

            int requestCount = 0;

            var reportWriter = new ReportWriter(RelativeAppPath);

            MessageDumper messageDumper = null;

            if (Config.DumpMessages)
                messageDumper = new MessageDumper(reportWriter.ReportPath.FullName);

            for (int urlCollectionIndex = 0; urlCollectionIndex < 2; urlCollectionIndex++)
            foreach (ScanPluginBase ScanPlugin in Config.ScanPlugins)
            {
                if (Config.CodeCoverageReport > 0)
                    ScanMetrics.Default.Reset();

                if (!urlCollections[urlCollectionIndex].Any())
                    continue;

                UI.DisplayScanPlugin(ScanPlugin);                
                
                foreach (var remotePath in urlCollections[urlCollectionIndex])
                {
                    UI.DisplayResourcePath(remotePath);

                    IEnumerable<IEnumerable<FunctionCall>> calls = null;
                    if (urlCollectionIndex == 0)
                    {
                        calls = Program.PageFieldTable[Config.WebRoot +
                            remotePath.Replace('/', '\\')]
                            .Select(x => x.Value.Select(y => new FunctionCall()
                            {
                                Name = x.Key,
                                ParameterValues = new List<string>() { y }
                            }));

                        
                    }
                    
                    for (int i = 0; i < ScanPlugin.ModeCount; i++)
                    {
                        foreach (var useStaticAnalysisInputs in new []
                        {
                            false,
                            true
                        })
                        {
                            var trace = new FileTrace();

                            if (useStaticAnalysisInputs && calls != null)
                            {
                                if (!calls.Any(x => x.Any()))
                                    continue;

                                //var any = Program.PageFieldTable[Config.WebRoot +
                                //    remotePath.Replace('/', '\\')]
                                //    .Any(x => x.Value.Any());

                                //if (!any)
                                //    continue;

                                foreach (var c in calls)
                                    trace.Calls.AddRange(c);
                            }

                            

                            

                            
                            //Console.ForegroundColor = ConsoleColor.White;

                            bool discoveredVars = true;

                            while (discoveredVars)
                            {
                                var traceFile = new FileInfo(traceFileName);

                                IO.TryAction(traceFile.Delete);

                                var client = new TcpClient()
                                {
                                    ReceiveTimeout = Config.Timeout,
                                    SendTimeout = Config.Timeout
                                };

                                while(!client.Connected)
                                    try
                                    {
                                        client.Connect(Config.Server, Config.Port);
                                    }
                                    catch (SocketException ex)
                                    {
                                        UI.DisplayError(ex.Message);

                                        Thread.Sleep(5000);
                                    }
                                
                                client.LingerState = new LingerOption(true, 0);

                                HttpResponse resp = null;

                                string req, respString = "";

                                using (var stream = client.GetStream())
                                {
                                    req = ScanPlugin.BuildRequest(i, remotePath, trace);

                                    if (Config.DumpMessages)
                                        messageDumper.Dump(req, requestCount, MessageType.Request);
                                    
                                    stream.WriteString(req);
                                    
                                    try
                                    {
                                        var discoveredVarCount = trace.Calls
                                            .Superglobals()
                                            .Select(x => new { x.Name, Value = x.ParameterValues[0] })
                                            .Distinct()
                                            .Count();

                                        var reader = new HttpResponseReader(stream);
                                        resp = reader.Read();
                                        respString = resp.CompleteResponse;

                                        UI.DisplayResponse(resp, i, discoveredVarCount);
                                    }
                                    catch (System.Net.Sockets.SocketException ex)
                                    {
                                        UI.DisplayResponseError(respString);
                                    }
                                    catch (System.IO.IOException ex)
                                    {
                                        UI.DisplayResponseError(respString);
                                    }

                                    //stream.Close();
                                }

                                if (urlCollectionIndex == 0 && resp != null)
                                {
                                    var urls = new UriParser()
                                    {
                                        TargetHost = Config.Server,
                                    }.Parse(resp.Body);

                                    foreach (var url in urls)
                                    {
                                        if (!ignoreExtensions.Any(x => url.ToLower().EndsWith("." + x)) &&
                                            !urlCollections[0].Contains(url) &&
                                            !urlCollections[1].Contains(url))
                                            urlCollections[1].Add(url);
                                    }
                                }
                                else
                                    Console.Write("");

                                
                                client.Close();

                                if (Config.DumpMessages)
                                    messageDumper.Dump(respString, requestCount, MessageType.Response);

                                requestCount++;

                                string traceText = "";

                                traceFile = new FileInfo(traceFileName);

                                FileTrace newTrace = null;

                                IO.TryAction(() =>
                                {
                                    //if (traceFile.Exists)
                                    //    using (var reader = traceFile.OpenText())
                                    //        traceText = reader.ReadToEnd();

                                    if (traceFile.Exists)
                                        using (var reader = traceFile.OpenText())
                                            newTrace = FileTrace.Parse(reader);
                                });

                                //var newTrace = FileTrace.Parse(traceText);

                                if (newTrace == null)
                                    newTrace = new FileTrace();
                                newTrace.Request = req;
                                newTrace.Response = respString;
                                newTrace.File = remotePath;

                                var alert = ScanPlugin.ScanTrace(newTrace);

                                //if (alert != null &&
                                //    alerts.Count(x => x.Trace.RawText == alert.Trace.RawText) == 0)
                                if (alert != null)
                                {
                                    if (Config.BeepOnAlert)
                                        Console.Beep();

                                    UI.DisplayAlert(alert);

                                    alerts.Add(alert);
                                    report.Append(alert.ToString());                                
                                }

                                discoveredVars = false;

                                //if (newTrace.Calls.Count < trace.Calls.Count)
                                //    throw new InvalidOperationException();

                                //if (newTrace.Calls.Count > trace.Calls.Count)
                                //    discoveredVars = true;
                                //else if (newTrace.Calls.Count == 0)
                                //    discoveredVars = false;
                                //else
                                    foreach (FunctionCall c in newTrace.Calls
                                        .Superglobals())
                                    {
                                        //var oldCalls = trace.Calls.Where(x =>
                                        //    x.Name == c.Name);

                                        var oldCalls = trace.Calls.Where(x =>
                                            x.Name == c.Name &&
                                            x.ParameterValues.SequenceEqual(c.ParameterValues));

                                        //if (oldCalls.Count() == 0 ||
                                        //    oldCalls.Count(x => x.Value == c.Value) == 0)
                                        if (!oldCalls.Any())
                                        {
                                            discoveredVars = true;
                                            break;

                                            //trace.Calls.Add(c);
                                        }
                                        else
                                            Console.Write("");
                                    }

                                    

                                var orphanedInputs = trace.Calls
                                    .Superglobals()
                                    .Where(x => !newTrace.Calls
                                        .Any(y => x.Name == y.Name && x.ParameterValues
                                            .SequenceEqual(y.ParameterValues)))
                                    .ToArray();

                                


                                //if (orphanedInputs.Any() && discoveredVars)

                                newTrace.Calls.AddRange(orphanedInputs);

                                trace = newTrace;
                            }

                            
                            map.AddTrace(trace);

                            if (Config.DiscoveryReport)
                            {
                                if (!traceTable.ContainsKey(ScanPlugin))
                                    traceTable.Add(ScanPlugin, new Dictionary<int, Dictionary<string, FileTrace>>());

                                if (!traceTable[ScanPlugin].ContainsKey(i))
                                    traceTable[ScanPlugin].Add(i, new Dictionary<string, FileTrace>());

                                if (!traceTable[ScanPlugin][i].ContainsKey(trace.File))
                                    traceTable[ScanPlugin][i].Add(trace.File, trace);
                                else
                                    traceTable[ScanPlugin][i][trace.File] = trace;
                            }

                            //traces.Add(t);
                        }
                    }
                }

                if (Config.CodeCoverageReport > 0 && urlCollectionIndex == 0)
                {
                    CodeCoverageTable coverage = null;

                    IO.TryAction(() =>
                    {
                        coverage = ScanMetrics.Default.CalculateCoverage();
                    });

                    coverageReport.AppendLine(ScanPlugin.ToString());
                    coverageReport.AppendLine(coverage.ToString() + "\r\n");
                }
            }

            

            reportWriter.Write("Vulnerability Report", report.ToString());

            if (Config.CodeCoverageReport > 0)
                reportWriter.Write("Code Coverage Report", coverageReport.ToString());

            reportWriter.Write("Input Map Report", map.ToXml(), "xml");
            

            if (alerts.Any())
            {
                var path = reportWriter.Write("Vulnerability Report", 
                    alerts.ToXml(), "pxml");

                //var path = Report.GetUniqueReportName(RelativeAppPath, "Vulnerability Report",
                //    "pxml");

                //alerts.Save(path);

                if (Config.RunViewer)
                {
                    var viewerPath = Assembly.GetExecutingAssembly().Location.RemoveAtLastIndexOf('\\', 1) +
                        @"PHPVHReportViewer.exe";

                    if (File.Exists(viewerPath))
                        System.Diagnostics.Process.Start(viewerPath, "\"" + path + "\"");
                    else
                        System.Windows.Forms.MessageBox.Show("Could not locate report viewer executable.",
                            "Error launching report viewer", System.Windows.Forms.MessageBoxButtons.OK,
                            System.Windows.Forms.MessageBoxIcon.Error);
                        
                }
            }

            if (Config.DiscoveryReport)
                reportWriter.Write("Scan Overview Report",
                    DiscoveryReport.Create(traceTable));
                //Report.Write(RelativeAppPath, "Scan Overview Report",
                //    DiscoveryReport.Create(traceTable));
        }
    }
}
