﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PHPScan
{
    public class ReportWriter
    {
        public DirectoryInfo ReportPath { get; private set; }

        public ReportWriter(string serverPath)
        {
            ReportPath = new DirectoryInfo(@".\" +
                serverPath.Replace('/', '_') + " Scan Reports " +
                DateTime.Now.ToString("MM-dd-yyyy-HHmmss"));
            ReportPath.Create();
        }

        public string Write(string name, string report, string extension)
        {
            var file = ReportPath + "\\" + name + "." + extension;

            if (!string.IsNullOrEmpty(report.ToString()))
            {
                File.WriteAllText(file, report.ToString());

                Console.WriteLine("\r\n{0} report written to {1}", name, file);

                return file;
            }

            return null;
        }

        public string Write(string name, string report)
        {
            return Write(name, report, "txt");
        }
    }
}
