﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using AutoSecTools.Components.Wpf;
using PHPScan;

namespace PHPVHReportViewer.ViewModels
{
    public class ScanViewModel : BaseViewModel
    {
        private Dictionary<string, Dictionary<string, List<object>>> _inputTable;

        public Dictionary<string, Dictionary<string, List<object>>> InputTable
        {
            get { return _inputTable; }
            set { _inputTable = value; InvokePropertyChanged("InputTable"); }
        }

        private ObservableCollection<AlertViewModel> _Alerts;
        
        public ObservableCollection<AlertViewModel> Alerts
        {
        	get { return _Alerts; }
        	set
        	{                
        		_Alerts = value;
        
        		InvokePropertyChanged("Alerts");
        	}
        }

        private AlertViewModel _CurrentAlert;

        public AlertViewModel CurrentAlert
        {
            get { return _CurrentAlert; }
            set
            {
                _CurrentAlert = value;

                InvokePropertyChanged("CurrentAlert");
            }
        }

        public ScanViewModel(FrameworkElement Element, BaseViewModel Parent)
            : base(Element, Parent)
        {
        }

        public ScanViewModel(FrameworkElement Element)
            : base(Element)
        {
            
        }

        public ScanViewModel()
            : base()
        {
        }

        public void CreateAlertViewModels(IEnumerable<ScanAlert> ScanAlerts)
        {
            //var map = ApplicationMap.FromXml(@"C:\Temp\Release\phpvh\source\PHPScan\PHPVH\bin\Debug\ebbv3 Scan Reports 12-30-2011-025756\input map report.xml");
            //InputTable = map.Pages
            //    .ToDictionary(x => x.Page,
            //        x => new Dictionary<string, List<object>>()
            //        {
            //            { "GET", x.Get.Select(y => (object)(new { Key = y })).ToList() },
            //            { "POST", x.Post.Select(y => (object)(new { Key = y })).ToList() },
            //            { "REQUEST", x.Request.Select(y => (object)(new { Key = y })).ToList() },
            //            { "Files", x.Files.Select(y => (object)(new { Key = y })).ToList() },
            //            { "Cookie", x.Cookie.Select(y => (object)(new { Key = y })).ToList() }
                        
            //        });

            Alerts = new ObservableCollection<AlertViewModel>(ScanAlerts.Select(x => new AlertViewModel(x)));

            CurrentAlert = Alerts.First();
        }
    }
}
